#include "mview.h"
#include <stdio.h>
#include	<string.h>
#include	<doslib.h>
#include <iocslib.h>
#include "console.h"
#include	"sub.h"

static char	keytbl[] = {
	/*         ESC    1!    2"    3#    4$    5%    6& */
		0x00, 0x01, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16,
	/*     7'   8(    9)     0    -=    ^~    \|    BS */
		0x17, 0x18, 0x19, 0x10, 0x1d, 0x3e, 0x3c, 0x02,
	/*   TAB     Q     W     E     R     T     Y     U */
		0x03, 0x31, 0x37, 0x25, 0x32, 0x34, 0x39, 0x35,
	/*     I     O     P    @`    [{    CR     A     S */
		0x29, 0x2f, 0x30, 0x20, 0x3b, 0x04, 0x21, 0x33,
	/*     D     F     G     H     J     K     L    ;+ */
		0x24, 0x26, 0x27, 0x28, 0x2a, 0x2b, 0x2c, 0x1b,
	/*    :*    ]}     Z     X     C     V     B     N */
		0x1a, 0x3d, 0x3a, 0x38, 0x23, 0x36, 0x22, 0x2e,
	/*     M    ,<    .>    /?     _ SPACE  HOME   DEL */
		0x2d, 0x1c, 0x1e, 0x1f, 0x3f, 0x05, 0x06, 0x07,
	/*  R_UP  R_DW  UNDO  LEFT    UP RIGHT  DOWN   CLR */
		0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f

	/*  TEN/  TEN*  TEN-  TEN7  TEN8  TEN9  TEN+  TEN4 */
	/*  TEN5  TEN6  TEN=  TEN1  TEN2  TEN3 ENTER  TEN0 */
	/*  TEN,  TEN.  KIGOU TOROK HELP   XF1   XF2   XF3 */
	/*   XF4   XF5  KANA  ROMA  CODE  CAPS   INS  HIRA */
	/*   ZEN BREAK  COPY    F0    F1    F2    F3    F4 */
	/*    F5    F6    F7    F8    F9                   */
	/* SHIFT  CTRL  OPT1  OPT2                         */
	/*	XLR[h = L[R[hO[v~W{L[͏ԃrbg*/
};

static char	WaitFlag = 0;

extern int	Formatstring(char *buf, MAILDATA*, int);


void	ColorPut(int y, int target, int cursor)
{
	int	color = WHITE, len;	/*  */

	if (!(Mail[target].fileflag & M_CHECK)) {
		color = BLUE;		/*  */
	}
	/* }[N */
	if (MailOn[target])	color |= REVERSE;

	len = Formatstring(PrnTemp, Mail, target);
	B_PUTMES(color, 1, y + 1, len, PrnTemp);
	if (cursor)	putul(1, y, ++len);
}

/* ʑ */
void	listredraw()
{
	int	y, i = StartNum, max = PAGEROW;
	char	*ptr = PrnTemp, *cursor;

	if (i + max > MailNow)	max = MailNow - i;

	for (y = 0; y < max; y++, i++) {
		char	color = WHITE;	/*  */

		if (!(Mail[i].fileflag & M_CHECK)) {
			color = BLUE;		/*  */
		}
		/* }[N */
		if (MailOn[i])	color |= REVERSE;
		*ptr++ = color;
		if (i == TargetNum)	cursor = ptr;
		ptr += Formatstring(ptr, Mail, i) + 2;
	}

	allput(1, max, PrnTemp);
	putul(1, TargetNum - StartNum, strlen(cursor));

	TitlePut(CDir);
	ConsolePut("[q]I [w]VK[ [f]ԐM[ [SPACE]}[N [k]폜 [m]ړ");
/*	StatusPut(NULL);*/
	PutNum = TargetNum - StartNum;
}

/* IOCS[gŃL[̓`FbNB͂܂ŌJԂ */
unsigned char	MKEY_GET(void)
{
	int	i, j, b;
	unsigned char	k = 0;

	while (1) {
		for (j = 0x00; j <= 0x07; j++) {
			if (i = BITSNS(j)) {
				for (b = 7; b >= 0; b--) {
					if (i & 0x80)	break;
					i += i;
				}
				k = keytbl[j * 8 + b];
				break;
			}
		}
		if (k) {
			if (i = BITSNS(0x0e)) {
				if (i & 0x01)	k |= 0x40;	/* SHIFT I */
				if (i & 0x02)	k |= 0x80;	/* CTRL  I */
			}
			return k;
		} else {
			WaitFlag = 0;
		}
	}
}

/* Aˋ֎~BCӂŌĂяo */
void	MKEY_WAIT(void)
{
	static int	OldTime;

	/* s[gȂ֎~`FbNȂ */
	if (WaitFlag == 2) {
		OldTime = ONTIME();	/* s[gɂEFCg */
		while (ONTIME() - OldTime < RepeatTime / 10);
		return;	
	} else if (!WaitFlag) {
		/* L[s[gJn܂ł̃EFCg */
		WaitFlag = 1;
		OldTime = ONTIME();	/* L^Ƃđҋ@ɂ܂킷 */
	}
	/* L[s[gJn܂ł̃EFCg*/
	while (1) {
		int i, j;

		for (i = 0x00, j = 0; i <= 0x07; i++)	j += BITSNS(i) & 0xff;

		if (!j)	break;

		if(ONTIME() - OldTime > RepeatTime) {
			WaitFlag = 2;
			break;
		}
	}
}

static void	putline(int color, int y, char *str)
{
	int	i;
	char	*p, *w = PrnTemp;

	if (p = str)	while (*p)	*w++ = *p++;
	i = w - PrnTemp;
	for (; i < 96; i++)	*w++ = ' ';
	*w = '\0';
	B_PUTMES(color, 0, y, 96 - 1, PrnTemp);
}

void	TitlePut(char *str)
{
	putline(BLUE|REVERSE, 0, str);
}

void	StatusPut(char *str)
{
	putline(WHITE, 30, str);
}

/* тŏ[U[ɓ` */
void	ConsolePut(char *Str)
{
	sprintf(PrnTemp, "mview v1.49 %-84s", Str);
	B_PUTMES(BLUE|BOLD|REVERSE, 0, 29, 96 - 1, PrnTemp);
}

/* (0,9)-(0,21) NA */
void	ConsoleExec(char *comline, char *title)
{
	int	ys;
	unsigned char	*ptr = PrnTemp;

	for (ys = 0; ys < 96 / 2; ys++) {
		*ptr++ = 0x84;	/* '' */
		*ptr++ = 0xaa;
	}
	*ptr = '\0';

	B_PUTMES(YELLOW, 0, 8, 96 - 1, PrnTemp);
	for (ys = 9; ys <= 21; ys++) {
		B_LOCATE(0, ys);
		C_ERA_AL();
	}
	B_PUTMES(YELLOW, 0, 22, 96 - 1, PrnTemp);

	B_COLOR(WHITE);
	C_WINDOW(9, 13);
	childexec(comline);
	C_WINDOW(0, 31);
	B_CUROFF();

	sprintf(PrnTemp, "%sI܂ccȂɂL[Ă", title);
	StatusPut(PrnTemp);
	MKEY_GET();
	StatusPut(NULL);
	PutScreen();
}
