#include "mview.h"
#include <stdio.h>
#include <stdlib.h>
#include <doslib.h>
#include <string.h>
#include	"dir.h"
#include	"mail.h"
#include	"sub.h"
#include	"console.h"

#define	PAGEROW	28

static DIRNAME	*add_dchain(int len);


/* Root+TDir ɃfBNg + BȂ -  */
char	CDirCheck(char *Root, char *TDir)
{
	int	FoundFile;
	struct FILBUF	files_buffer;
	char	Str[FILNMAX];

	strcpy(Str, Root);	/* fBNg */
	strcat(Str, TDir);
	strcat(Str, "\\");
	strcat(Str, "*.*");

	FoundFile = FILES(&files_buffer, Str, 0x10 );

	/* A */
	while (FoundFile >= 0) {
		/* .  .. ͊O */
		if (strcmp(files_buffer.name, "." )
				&& strcmp (files_buffer.name, ".."))
			return '+';
		FoundFile = NFILES(&files_buffer);
	}
	return '-';
}

/* cd.. ɑ鏈 */
void	CDirPre(void)
{
	char	*child = NULL, *ptr = CDir;

	while (*ptr) {
		if (*ptr == '\\' && *(ptr + 1))	child = ptr;
		ptr++;
	}
	if (child)	*(child + 1) = '\0';
}

static DIRNAME	*
add_dchain(len)
int	len;
{
	DIRNAME	*newptr;

	newptr = malloc(sizeof(DIRNAME) + len);
	if (!newptr)	quitop("܂\n");

	newptr->next = NULL;
	if (dhead) {
		DIRNAME	*parent = dhead;

		while (parent->next)	parent = parent->next;
		parent->next = newptr;
	} else {
		dhead = newptr;
	}
	return newptr;
}

void
del_dchain(parent)
DIRNAME	*parent;
{
	while (parent) {
		DIRNAME	*child = parent->next;

		free(parent);
		parent = child;
	}
}

/* CDir̃fBNgTccȂ 0 Ԃ */
int	DIRGET(char *cdir, int outinf)
{
	FILE	*fp;
	DIRNAME	*tmp;
	int	DSaveFlag = FALSE;
	int	FoundFile;
	struct FILBUF	files_buffer;
	char	Temp[BUFMAX], FileName[FILNMAX];

	/*  */
	dhead = NULL;
	DirNow = 0;

	/* DIR.INF ̓ǂݍ */
	if (outinf) {
		strcpy(FileName, cdir);
		strcat(FileName, "DIR.INF");

		if (fp = fopen(FileName, "rt")) {
			while (fgets(Temp, BUFMAX, fp)) {
				char	*r, *w;

				/* s̉s폜 */
				for (r = Temp; *r && *r != '\n'; r++);
				*r = '\0';

				tmp = add_dchain(r - Temp);
				tmp->exist = FALSE;

				/* ^u܂ŃRs[ */
				r = Temp;
				for (w = tmp->buf; *r && *r != '\t';) {
					*w++ = *r++;
				}
				*w++ = '\0';

				/* ^uXLbv */
				for (; *r && *r == '\t'; r++);

				/* cIvVl[ */
				while (*r)	*w++ = *r++;
				*w = '\0';

				DirNow++;
			}
			fclose(fp);
		}
	}

	strcpy(Temp, cdir);
	strcat(Temp, "*.*");

	FoundFile = FILES(&files_buffer, Temp, 0x10);

	/* A */
	while (FoundFile >= 0) {
		/* .  .. ͑ΏۊO */
		if (strcmp(files_buffer.name, "." )
				&& strcmp(files_buffer.name, "..")) {

			/* fBNg DIR.INF ɂ邩ׂ */
			tmp = dhead;
			while (tmp) {
				if (!strcmpi(tmp->buf, files_buffer.name)) {
					tmp->exist = TRUE;
					break;
				}
				tmp = tmp->next;
			}
			/* !strcmpi s = VfBNg */
			if (!tmp) {
				tmp = add_dchain(strlen(files_buffer.name));
				tmp->exist = TRUE;
				strcpy(tmp->buf, files_buffer.name);
				DirNow++;
				DSaveFlag = TRUE;
			}
		}
		FoundFile = NFILES(&files_buffer);
	}

	if (outinf) {
		DIRNAME	*parent = dhead;
		tmp = dhead;
		while (tmp) {
			DIRNAME	*child = tmp->next;
			if (tmp->exist) {
				parent = tmp;
			} else {
				/* 폜ꂽfBNg */
				if (parent == dhead) {
					parent = dhead = child;
				} else {
					parent->next = child;
				}
				free(tmp);
				DirNow--;
				DSaveFlag = TRUE;
			}
			tmp = child;
		}
	}

	/* fBNg`FbN */
	if (!DirNow) {
		/* .  .. ȊOȂ΃[paBNg */
		/* Mailbox ̃TufBNgȂʏI */
		if (!outinf || Dir)	return FALSE;

		/* Mailbox ȂΊݒ肪łĂȂ */
		quitop("[{bNX̐ݒ@ĒׂĂ\n");
	}

	/* DIR.INF ɕۑ */
	if (outinf && DSaveFlag) {
		if (fp = fopen(FileName, "wt")) {
			tmp = dhead;
			while (tmp) {
				char	*p = tmp->buf;

				while (*p)	fputc(*p++, fp);
				if (!*++p)	p = tmp->buf;

				/* Option Name */
				fputc('\t', fp);
				fputs(p, fp);
				fputc('\n', fp);

				tmp = tmp->next;
			}
			fclose(fp);
		} else {
			StatusPut("DIR.INF ɏ߂܂");
		}
	}

	/* fBNgKwł */
	return TRUE;
}

void	DIRSET(void)
{
	DIRNAME	*tmp;

	if (Mail) {
		free(Mail);
		Mail = NULL;
	}
	if (MailOn) {
		free(MailOn);
		MailOn = NULL;
	}
	Mail = malloc(DirNow * sizeof(MAILDATA));
	MailOn = malloc(DirNow);
	if (!Mail || !MailOn)	quitop("܂");

	/* Zbg */
	MailNow = 0;
	tmp = dhead;
	while (tmp) {
		DIRNAME	*child = tmp->next;
		char	*p = tmp->buf, *w;

		for (w = Mail[MailNow].title; *p; *w++ = *p++);
		*w = '\0';
		jstrncpy(Mail[MailNow].name, p, MNAME_MAX);
		Mail[MailNow].type = 0;
		Mail[MailNow].fileflag = CDirCheck(CDir, tmp->buf);
		MailOn[MailNow++] = FALSE;	/* łɏ */
		free(tmp);
		tmp = child;
	}
	StartNum = 0;
	TargetNum = 0;
}
