#include "mview.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "window.h"
#include "mime.h"
#include "dir.h"
#include "mail.h"
#include "console.h"
#include "move.h"
#include "func.h"
#include	"sub.h"
#include	"view.h"

static int	headcmp(char *str, char *key);
static int	yesno(char *message);
static int	smailopt();

static int	yesno(char *message)
{
	unsigned char	Key;

	StatusPut(message);

	MKEY_WAIT();
	Key = MKEY_GET();
	if (Key != KEYY) {
		StatusPut("~܂");
		return FALSE;
	}
	return TRUE;
}

void	MailView(void)
{
	int	targetbak = TargetNum;
	unsigned char	filename[FILNMAX];

	do {
		strcpy(filename, CDir);
		strcat(filename, Mail[TargetNum].filename);

		if (!SendFlag && !(Mail[TargetNum].fileflag & M_CHECK)) {
			/* SENDnȊÕtH_Ȃǃ}[N */
			Mail[TargetNum].fileflag |= M_CHECK;
			SaveFlag = TRUE;
		}
	} while (viewopen(filename));

	TargetNum = targetbak;
	PutScreen();
}

void	AllMark(void)
{
	int	i, k;

/*	if (!Dir)	quitop(NULL);*/

	if (MarkNum) {
		k = FALSE;
		MarkNum = 0;
	} else {
		k = TRUE;
		MarkNum = MailNow;
	}
	for (i = 0; i < MailNow; i++)	MailOn[i] = k;
	PutScreen();
}

static int
smailopt()
{
	int	i;
	SUBINF	inf;

	if (!alloc_subwin(&inf, Env.SmailNow)) {
		return 0;
	}
	inf.WinMax = Env.SmailNow;
	for (i = 0; i < Env.SmailNow; i++) {
		strcpy(inf.WinMember[i].name, Env.SmailName[i]);
	}

	/* IȂ */
	i = WinManager(&inf, "    smail IvV", 0);
	free_subwin(&inf);

	return i;
}

char	NormalSent(void)
{
	FILE	*fp;
	int	i, j;
	unsigned char	FileName[FILNMAX];
	unsigned char	comline[256];

	StatusPut("[M");

	/* smail optionI(S[) */
	if (Env.SmailNow) {
		i = smailopt();
		PutScreen();

		/* ~ */
		if (i < 0)	return FALSE;
	} else {
		i = 0;
	}

	strcpy(FileName, Env.tempbox);
	strcat(FileName, "mview.tmp");	/* Xg̏ */
	fp = fopen(FileName, "wt");
	if (!fp) {
		StatusPut("ꎞt@C쐬ł܂");
		return FALSE;
	}

	/* Xg̍쐬O`FbN */
	for (j = 0; j < MailNow; j++) {
		if (MailOn[j]) {
			fprintf(fp, "0 %s%s\n", CDir, Mail[j].filename);
		}
	}
	fclose(fp);

	if (i) {
		sprintf(comline, "smail -P%s %s", FileName, Env.SmailOption[i]);
	} else {
		sprintf(comline, "smail -P%s", FileName);
	}
	/* s */
	ConsoleExec(comline, "[M");

	fp = fopen(FileName, "rt");
	if (!fp) {
		StatusPut("ꎞt@Cǂ߂܂");
		return FALSE;
	}

	/* }[N̕tƖM̕ύX */
	for (j = 0; j < MailNow; j++) {
		if (MailOn[j]) {
			fgets(comline, 256, fp);
			if (comline[0] == '1') {
				/* M */
				if (!(Mail[j].fileflag & M_CHECK)) {
					Mail[j].fileflag |= M_CHECK;
					SaveFlag = TRUE;
				}
			} else {
				MailOn[j] = FALSE;	/* s}[NO */
				if (!MarkNum--)	break;
			}
		}
	}
	fclose(fp);
	remove(FileName);

	/* I[gړ */
	if (Env.Sentbox && SendFlag == 2) {
		char	MoveTargetDir[FILNMAX];	/* ړfBNg */

		PutScreen();

		strcpy(MoveTargetDir, Env.Mailbox);
		strcat(MoveTargetDir, Env.Sentbox);
		PlusSlash(MoveTargetDir);

		Move(MoveTargetDir);
	} else if (MarkNum) {
		AllMark();
	}

	if (MailNow) {
		PutScreen();
		return FALSE;
	} else {
		CDirPre();
		Dir--;
		return TRUE;
	}
}

/* M[ɂׂă}[N */
void	AllSent(void)
{
	int	Target;

	for (Target = 0; Target < MailNow; Target++) {
		if (!(Mail[Target].fileflag & M_CHECK)) {
			MailOn[Target] = TRUE;
			MarkNum++;
		}
	}
}

int	MailEdit(void)
{
	char	filename[FILNMAX];

	/* Mς`FbN */
	if (Mail[TargetNum].fileflag & M_CHECK) {
		if (!yesno("̃[͂łɑMςłBłҏW܂H [y/n]"))
			return FALSE;
	}
	strcpy(filename, CDir);
	strcat(filename, Mail[TargetNum].filename);
	return execedit(filename, FALSE);
}

int	MimeClip(void)
{
	int	ret;

	if (ret = Env.Mimebox ? MimeManagerBox(Mail[TargetNum].filename)
					: MimeManagerFree(Mail[TargetNum].filename)) {
		if (!(Mail[TargetNum].fileflag & M_CLIP)) {
			Mail[TargetNum].fileflag |= M_CLIP;
			SaveFlag = TRUE;
		}
	}

	PutScreen();
	return ret;
}

/* MIMEWJ@\ */
void	MimeExtract(MAILDATA *mail, char *dir)
{
	char	cmdline[256];

	if (Env.Mimebox) {
		sprintf(cmdline, "maish -b%s %s%s", Env.Mimebox, dir,  mail->filename);
		ConsoleExec(cmdline, "Ytt@CWJ");
	}
}

char	MailMove(void)
{
	if (!MailOn[TargetNum] && !MarkNum) {
		MailOn[TargetNum] = TRUE;
		MarkNum++;
	}
	MoveManager();
	if (MailNow) {
		PutScreen();
		return FALSE;
	} else {
		CDirPre();
		Dir--;
		return TRUE;
	}
}

char	MailKill(void)
{
	if (SendFlag != 2 && !TrashFlag) {
		if (!yesno("[ݔɈړ܂H [y/n]"))
			return FALSE;
	} else {
		if (!yesno("[폜܂H [y/n]"))
			return FALSE;
	}

	if (!MailOn[TargetNum] && !MarkNum) {
		MailOn[TargetNum] = TRUE;
		MarkNum++;
	}
	if (SendFlag != 2 && !TrashFlag) {
		char	MoveTargetDir[FILNMAX];	/* ړfBNg */

		strcpy(MoveTargetDir, Env.Mailbox);
		strcat(MoveTargetDir, "Trash\\");
		Move(MoveTargetDir);
		if (!MailNow) {
			CDirPre();
			Dir--;
			return TRUE;
		}
	} else {
		Remove();		/* SendTrashł͑ɏ */
	}
	if (MailNow) {
		PutScreen();
		return FALSE;
	} else {
		CDirPre();
		Dir--;
		return TRUE;
	}
}

void
copymail(mail, dir)
MAILDATA	*mail;
char	*dir;
{
	int	i;
	char	*ptr, comline[256];
	GETLINE	k;

	/* \̏ */
	k.cursor = 0;
	k.kanji = FALSE;
	k.bufsize = FILNMAX;
	k.len = 0;
	k.home = 0;
	k.width = 96 - 12 - 1;
	k.x = 12;
	k.y = 30;
	k.color = WHITE;
	k.user = dummy;
	k.ctrltbl = ctrlmap;
	k.specialtbl = specialmap;
	k.buf = malloc(FILNMAX);
	if (!k.buf) {
		StatusPut("܂");
		return;
	}
	k.buf[0] = '\0';

	StatusPut("t@C: ");

	i = kinput(&k);

	if (i > 0) {
		for (ptr = k.buf; *ptr; ptr++) {
			if (slash == '/') {
				if (*ptr == '\\')	*ptr= '/';
			} else {
				if (*ptr == '/')	*ptr= '\\';
			}
		}
		sprintf(comline, "command.x copy %s%s %s",
				dir, mail->filename, k.buf);
		ConsoleExec(comline, "[ʖۑ");
	} else {
		StatusPut(NULL);
	}
	free(k.buf);
}


void
receive()
{
	/* s */
	ConsoleExec("spop.x", "[M");
	if (DirFlag && !SendFlag && !TrashFlag) {
		SaveInf();
		FILEGET();
		SaveFlag = FALSE;
		PutScreen();
	}
}

static int
headcmp(char *str, char *key)
{
	while (*key) {
		if (*str++ != *key++) {
			return FALSE;
		}
	}
	return TRUE;
}

int
AutoMove()
{
	int	i, j;
	char	temp[256];

	for (i = 0; i < Env.AutoMoveNow; i++) {
		char	*r, *w;

		r = Env.Mailbox;
		w = temp;
		while (*r)	*w++ = *r++;

		r = Env.AutoMove[i];
		while (*r && *r != '\t')	*w++ = *r++;
		if (!*r++)	break;
		*w++ = '\\';
		*w = '\0';

		w = r;
		while (*r && *r != '\t')	r++;
		if (!*r)	break;
		*r++ = '\0';
		if (strcmpi(w, "SUBJECT:"))	break;

		MarkNum = 0;
		for (j = 0; j < MailNow; j++) {
			if (headcmp(Mail[j].title, r)) {
				MailOn[j] = TRUE;
				MarkNum++;
			} else {
				MailOn[j] = FALSE;
			}
		}
		if (MarkNum) {
			Move(temp);
			if (!MailNow) {
				CDirPre();
				Dir--;
				return TRUE;
			}
		}
	}

	MarkNum = 0;
	for (j = 0; j < MailNow; j++)	MailOn[j] = FALSE;
	PutScreen();
	return FALSE;
}
