#include "mview.h"
#include <stdio.h>
#include	<stdlib.h>
#include <string.h>
#include <time.h>
#include	<doslib.h>
#include	"mail.h"
#include	"console.h"
#include	"sub.h"

static int	maxmail = 0; 
static unsigned char *Month[12] = {
		"Jan", "Feb", "Mar", "Apr", "May", "Jun",
		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

static int	alloc_mail(int);
static int	readmailinf();
static void	MailTempInit(MAILDATA*);
static void	ReinfofSend();


static int
alloc_mail(size)
int	size;
{
/*	if (maxmail >= size)	return TRUE;*/
	if (Mail)	free(Mail);
	if (MailOn)	free(MailOn);

	if (size < MAILMAX) {
		maxmail = MAILMAX;
	} else {
		maxmail = size;
	}

	Mail = malloc(sizeof(MAILDATA) * maxmail);
	if (Mail) {
		MailOn = malloc(sizeof(char) * maxmail);
		if (!MailOn) {
			free(Mail);
			Mail = NULL;
		}
	}

	if (!Mail) {
		maxmail = 0;
		StatusPut("[p̃mۂł܂");
		return FALSE;
	}
	return TRUE;
}

static int
readmailinf()
{
	short	fn;
	unsigned char	INFFile[FILNMAX];

	MailNow = 0;					/* [ */

	strcpy(INFFile, CDir);
	strcat(INFFile, MAILLIST);

	fn = OPEN(INFFile, 0);
	if (fn < 0) {					/* MAILLISTȂ */
		if (!alloc_mail(MAILMAX))	return -1;
	} else {
		READ(fn, (char*)(&MailNow), 4);	/* MAILLISTǂݍ */
		if (!MailNow) {				/* [ȂΖ߂ */
			CLOSE(fn);
			if (!alloc_mail(MAILMAX))	return -1;
			return 0;
		} else if (!alloc_mail(MailNow * 2)) {
			CLOSE(fn);
			MailNow = 0;
			return -1;
		}
		READ(fn, (char*)Mail, sizeof(MAILDATA) * MailNow);
		CLOSE(fn);
	}
	return MailNow;
}

void	MakeInf(void)
{
	MAILDATA	*MailTemp;
	FILE	*fp;
	int	i, SpoolNow = 0;
	char	GetFlag;	/* wb_EH */
	char	FromFlag, *Temp;
	char	filename[FILNMAX], TempStr[BUFMAX];

	GetNewName(NULL, NULL);

	while (1) {
		if (MailNow >= maxmail) {
			if (SpoolNow)	SaveFlag = TRUE;
			SaveInf();
			if (readmailinf() < 0)	return;
		}
		MailTemp = &(Mail[MailNow]);

		sprintf(TempStr, "%s%d", CDir, SpoolNow);
		if (!(fp = fopen(TempStr, "rt")))	break;
		strcpy(filename, TempStr);

		sprintf(TempStr, "V[荞ł܂ ... %d", SpoolNow);
		StatusPut(TempStr);

	/* oOɏ */
		/* t@Ĉݎ擾 */
		MailTemp->title[0] = '\0';
		MailTemp->name[0] = '\0';
		MailTemp->year[0] = '\0';
		MailTemp->time[0] = '\0';
		MailTemp->fileflag = 0;
		if( SendFlag == 2 ){
			MailTempInit(MailTemp);
		}else {
			MailTemp->year_v= 0;
			MailTemp->time_v= 0;
		}

		GetFlag = 0;
		FromFlag = FALSE;

		/* 邾̃f[^Bswb_ĨTC */
		while (fgets822a(TempStr, BUFMAX, fp)) {
			decode_mime(TempStr, TempStr);

			/* ^Cg擾 */
			if (Temp= GetKeyword(TempStr, "SUBJECT:")) {
				GetFlag++;
				strcpy(MailTemp->title, CutStr2(Temp, MSUBJECT_MAX));
				continue;
			}

			if ((!SendFlag && (Temp = GetKeyword(TempStr, "FROM:")))
					|| (SendFlag && (Temp = GetKeyword(TempStr, "TO:")))) {
				FromFlag = TRUE;
				GetFlag++;
				 /* O擾 */
				extract_name(MailTemp->name, Temp, MNAME_MAX);
				continue;
			}

			 /* Return-Path擾(FromȂɑp) */
			if ((Temp = GetKeyword(TempStr, "RETURN-PATH:")) && !FromFlag) {
				char	*w = TempStr;

				GetFlag++;
				 /* Return-xx<̎ */
				while (*Temp && *Temp != '<')	Temp++;
				if (Temp)	Temp++;
				/* O𒊏o */
				while (*Temp && *Temp != '>')	*w++ = *Temp++;
				*w = '\0';
				strcpy(MailTemp->name, CutStr2(TempStr, MNAME_MAX));
				continue;
			}

			/* t̎擾 */
			if (Temp = GetKeyword(TempStr, "DATE:")) {
				int	date, year;
				char	*month, *time,
						*time0, *time1, *time2;

				GetFlag++;
				strcpy(TempStr, Temp);	/* Date: ̎𒊏o */

				/* jꍇ̓J}̌Ȃ̂ł炷 */
				if (Temp= strchr(TempStr, ',')) {
					Temp += 1;
				} else {
					Temp = TempStr;
				}

				/* g[NŊēo */
				date = atoi(strtok(Temp, " "));
				month = strtok(NULL, " ");
				year = atoi(strtok( NULL, " "));
				time = strtok(NULL, " ");
				time[8] = '\0';

				if (year < 100) {	/* QȂ␳ */
					if (year >= 70) {
						year += 1900;
					} else {
						year += 2000;
					}
				}

				for (i = 0; i < 12; i++) {
					if (!strcmp(month, Month[i]))	break;
				}
				i++;
				sprintf(MailTemp->year, "%4.4d-%2.2d-%2.2d", year, i, date);

				/* r̂߂̌vZ */
				MailTemp->year_v = year;
				MailTemp->year_v =  MailTemp->year_v * 100 + i;
				MailTemp->year_v =  MailTemp->year_v * 100 + date;

				if (!strchr(time, ':')) {
					/* ΉĂȂł00:00:00ŕ] */
					MailTemp->time_v = 0;
					strcpy(MailTemp->time, "00:00:00");
				} else {
					strcpy(MailTemp->time, time);
					time0 = strtok(time, ":");
					time1 = strtok(NULL, ":");
					time2 = time + 6;
					MailTemp->time_v = atoi(time0) * 10000
										+ atoi(time1) * 100 + atoi(time2);
				}
				continue;
			}

			/* wb_ boundary= ΃}`p[g */
			if (strstr(TempStr, "boundary=")) {
				MailTemp->fileflag |= M_CLIP;
			}
		}
		fclose(fp);
		MailTemp->type = 1;

		 /* 擾wb_eQȏȂ烁[ƂĔF߂B
		 	SendFlag΂Pŕs */
		if (GetFlag > 1 - SendFlag) {
			Temp = GetNewName(CDir, MailTemp);
			strcpy(TempStr, CDir);
			strcat(TempStr, Temp);
			if (rename(filename, TempStr) == -1) {
				/* l[sI */
				sprintf(PrnTemp, "%s  %s Ƀl[ł܂", filename, Temp);
				StatusPut(PrnTemp);
				break;
			}
			strcpy(MailTemp->filename, Temp);
			MailOn[MailNow++] = FALSE;
		} else {
			sprintf(TempStr, "[ƂĔFł܂ ... %d\n", SpoolNow);
			StatusPut(TempStr);
			break;
		}

		SpoolNow++;	/* ɐV[ */
	}
	/* [ȂΖ߂ */
	if (SpoolNow)	SaveFlag = TRUE;	/* SaveInf() ŃZ[u\ */
}

static void
MailTempInit(MailTemp)
MAILDATA	*MailTemp;
{
	int	temp, i, j, k;

	/* Sendt@C̏ꍇADate:Ȃ̂ŌݎZbgĂ */
	temp = GETDATE();
	i = (((temp >> 9) & 127) % 100) + 1980;
	j = (temp >> 5) & 15;
	k = temp & 31;

	sprintf(MailTemp->year, "%4.4d-%2.2d-%2.2d", i, j, k);

	/* r̂߂̌vZ */
	MailTemp->year_v = i * 10000 + j * 100 + k;

	temp= GETTIM2();
	i = (temp >> 16) & 31;
	j = (temp >> 8) & 63;
	k = temp & 63;

	sprintf(MailTemp->time, "%2.2d:%2.2d:%2.2d", i, j, k);

	MailTemp->time_v = i * 10000 + j * 100 + k;
}

/*	SENDnfBNgMAILLIST蒼 */
void
ReinfofSend()
{
	int	GetFlag;
	int	j;
	FILE	*fp;
	char	*Temp, TempStr[BUFMAX];
	MAILDATA	mailtemp;

	StatusPut("[XV");
	for (j = 0; j < MailNow; j++) {
		strcpy(TempStr, CDir);
		strcat(TempStr, Mail[j].filename);
		if (!(fp = fopen(TempStr, "rt")))	continue;

		GetFlag= 0;

		/* 邾̃f[^Bswb_ĨTC */
		while (fgets822a(TempStr, sizeof(TempStr), fp)) {
			decode_mime(TempStr, TempStr);

			/* From, To `FbNςsŒI */
			if (GetFlag > 1 || TempStr[0] == '\n' )	break;

			/* ^Cg擾 */
			if (Temp = GetKeyword(TempStr, "SUBJECT:")) {
				GetFlag++;
				CutStr2(Temp, MSUBJECT_MAX);
				if (strcmp(Mail[j].title, Temp)) {
					strcpy(Mail[j].title, Temp);
					SaveFlag = TRUE;
				}
				continue;
			}

			/* O擾 */
			if (Temp = GetKeyword(TempStr, "TO:")){
				GetFlag++;
				extract_name(mailtemp.name, Temp, MNAME_MAX);
				if (strcmp(Mail[j].name, mailtemp.name)) {
					strcpy(Mail[j].name, mailtemp.name);
					SaveFlag = TRUE;
				}
				continue;
			}
		}
		fclose(fp);
	}
}

void	SaveInf(void)
{
	unsigned char	INFFile[FILNMAX];

	/* Z[uKvȂ΂܂ */
	if (!SaveFlag)	return;
	SaveFlag = FALSE;

	strcpy(INFFile, CDir);
	strcat(INFFile, MAILLIST);
	mailsort(INFFile, Mail, MailNow);
	readmailinf();
}

void	RemoveInf(void)
{
	char	FileName[FILNMAX];

	strcpy(FileName, CDir);
	strcat(FileName, MAILLIST);

	if (remove(FileName) == -1) {
		StatusPut("INFt@C폜ł܂");
	}

}

/* [̎擾B܂MAILLISTTAȂ΍쐬 */
void	FILEGET()
{
	int	i;

	StartNum = 0;
	TargetNum= 0;
	MarkNum= 0;
	SaveFlag = FALSE;

	StatusPut("[ꗗ");
	i= readmailinf();
	if (i < 0)	return;
	if (i && SendFlag == 2)	ReinfofSend();

	MakeInf();				/* [ */
	if (!MailNow)	return;
	SaveInf();

	for (i = 0; i < MailNow; i++) {
		MailOn[i] = FALSE;	/* }[N */
	}

	/* seekflagݒ肪΁AJ[\𖖒[ */
	if (Env.SeekFlag) {
		TargetNum = MailNow - 1;
		StartNum = MailNow - PAGEROW;
	} else {
		TargetNum = 0;
	}

	/* J[\𖢓ǁEMʒu */
	for (i = 0; i < MailNow; i++) {
		if (!(Mail[i].fileflag & M_CHECK)) {
			/* (̐擪) */
			TargetNum= i;
			StartNum = i;
			if (i + PAGEROW > MailNow) {
				StartNum = MailNow - PAGEROW;
			}
			break;
		}
	}
	if (StartNum < 0)	StartNum = 0;
}
