#include "mview.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sub.h"
#include "console.h"
#include	"mail.h"


#define	KEYNUM	20
#define	MAILBOX_SET	1
#define	EDITOR_SET	2

static char	*catpack(char **head, char *dest, char *src);
void	GetEnvRc(char *progpath);

static char	*catpack(char **head, char *dest, char *src)
{
	*head = dest;

	while (*src)	*dest++ = *src++;
	*dest++ = '\0';

	return dest;
}

/* ǂݏo */
void	GetEnvRc(char *progpath)
{
	FILE	*fp;
	char	*r, *w, Temp[BUFMAX];
	char	Flag = 0;	/* K{ݒtO */
	static char	*envkey[KEYNUM] = {
			"MAILBOX", "EDITOR", "OPTION NAME", "SMAIL OPTION",
			"SIGNATURE NAME", "SIGNATURE FILE", "MIMEBOX",
			"FIRSTSEEK", "REPEATTIME",
			"QUOTATION MARK", "DEFAULT SUBJECT", "DEFAULT REPLY",
			"DEFAULT CC", "SENTBOX", "REPLYHEAD", "RESOLVE",
			"XCC", "SORT", "DEFAULT CHARSET", "RULE"
	};

	r = getenv("MVIEWRC");
	if (r) {
		strcpy(Temp, r);
	} else {
		/* ϐMVIEWRCݒ肳ĂȂ΁AJgfBNgT */
		int i;
		strcpy(Temp, progpath);
		for (i = strlen(Temp) - 1; i; i--)
			if (Temp[i] == '.') {	/* sIhŎ~߂ */
				Temp[i] = '\0';
				break;
			}
		strcat(Temp, ".RC");
	}

	{	int	size = fsize(Temp);
		if (size < 0) {
			sprintf(Temp, "t@C %s ܂\n", Temp);
			quitop(Temp);
		}
		Env.pack = malloc(size + 256);
	}

	if (!Env.pack)	quitop("܂");
	w = Env.pack;

	/* tO֌W̏ */
	Env.Qmark = NULL;
	Env.DefSubject = NULL;
	Env.Mimebox = NULL;
	Env.Sentbox = NULL;
	Env.Reply = NULL;
	Env.Cc = NULL;
	Env.replyhead = NULL;
	Env.xcc = NULL;
	Env.SeekFlag = 0;
	RepeatTime = 1 * 100;
	Env.FilePutFlag = 0;
	Env.sort = 0;
	Env.defconverter = jis2sjis;

	Env.SignatureNow = 0;
	w = catpack(&(Env.SignatureName[0]), w, "gȂ");

	Env.SmailNow = 0;
	w = catpack(&(Env.SmailName[0]), w, "ʏ푗M");
	w = catpack(&(Env.SmailOption[0]), w, "");

	Env.AutoMoveNow = 0;

	fp = fopen(Temp, "rt");
/*
	if (!fp) {
		sprintf(Temp, "t@C%s܂\n", Temp);
		quitop(Temp);
	}
*/
	/* t@Cǂœe */
	while (fgets(Temp, 256, fp)) {
		int	i = KEYNUM;

		/* ߂Ƌs͖ */
		if (Temp[0] == '#' || Temp[0] == '\n')	continue;

		while (--i >= 0) {
			if (r = GetKeyword(Temp, envkey[i]))	break;
		}

		switch (i) {
		case 0:
			PlusSlash(r);
			w = catpack(&(Env.Mailbox), w, r);
			Flag |= MAILBOX_SET;
			break;
		case 1:
			w = catpack(&(Env.Med), w, r);
			Flag |= EDITOR_SET;
			break;
		case 2:
			if (!Env.SmailNow)	Env.SmailNow = 1;
			w = catpack(&(Env.SmailName[Env.SmailNow]), w, r);
			break;
		case 3:
			if (!Env.SmailNow)	Env.SmailNow = 1;
			w = catpack(&(Env.SmailOption[Env.SmailNow++]), w, r);
			break;
		case 4:
			if (!Env.SignatureNow)	Env.SignatureNow = 1;
			w = catpack(&(Env.SignatureName[Env.SignatureNow]), w, r);
			break;
		case 5:
			if (!Env.SignatureNow)	Env.SignatureNow = 1;
			w = catpack(&(Env.SignatureFile[Env.SignatureNow++]), w, r);
			break;
		case 6:
			PlusSlash(r);
			w = catpack(&(Env.Mimebox), w, r);
			break;
		case 7:
			if (!strcmpi(r, "start"))	Env.SeekFlag = FALSE;
			else if (!strcmpi(r, "end"))	Env.SeekFlag = TRUE;
			break;
		case 8:
			RepeatTime = atoi(r);
			break;
		case 9:
			w = catpack(&(Env.Qmark), w, r);
			break;
		case 10:
			w = catpack(&(Env.DefSubject), w, r);
			break;
		case 11:
			w = catpack(&(Env.Reply), w, r);
			break;
		case 12:
			w = catpack(&(Env.Cc), w, r);
			break;
		case 13:
			w = catpack(&(Env.Sentbox), w, r);
			break;
		case 14:
			w = catpack(&(Env.replyhead), w, r);
			break;
		case 15:
			Env.resolve = !strcmpi(r, "on");
			break;
		case 16:
			w = catpack(&(Env.xcc), w, r);
			break;
		case 17:
			Env.sort = !strcmpi(r, "time");
			break;
		case 18:
			if (!strcmpi(r, "EUC")) {
				Env.defconverter = euc2sjis;
			} else if (strcmpi(r, "JIS")) {
				Env.defconverter = NULL;
			}
			break;
		case 19:
			w = catpack(&(Env.AutoMove[Env.AutoMoveNow++]), w, r);
			break;
		}
	}
	fclose(fp);
	if (Flag != (MAILBOX_SET|EDITOR_SET)) {
		quitop("t@CɕK{ڂݒ肳Ă܂");
	}

	/* tO֌W̏ */
	if (!Env.Qmark)	w = catpack(&(Env.Qmark), w, "> ");
	if (!Env.DefSubject)	w = catpack(&(Env.DefSubject), w, "*NoTitle*");
	if (!Env.Cc)	 w = catpack(&(Env.Cc), w, "");

	chkshell();
	r = getenv("TEMP");
	if (!r) {
		r = getenv("temp");
		if (!r)	r = Env.Mailbox;
	}
	r = strcpy(Temp, r);
	while (*r) {
		if (*r == '/')	*r = '\\';
		r++;
	}
	PlusSlash(Temp);
	w = catpack(&(Env.tempbox), w, Temp);

	realloc(Env.pack, (int)(w - Env.pack));
}
