#include "mview.h"
#include <stdio.h>
#include	<stdlib.h>
#include <string.h>
#include	"window.h"
#include	"console.h"
#include	"mail.h"
#include	"sub.h"
#include	"address.h"

#define	RESSTR_MAX	128
#define	LINE_MAX	256

typedef struct {
	void	*next;
	char	buf[1];
} CHAIN;

typedef struct{
	CHAIN	*to;
	char	MesID[RESSTR_MAX];
	char	subject[RESSTR_MAX];
}	RES;

static char	*MakeResTitle(char *title, char *GetStr);	/* ԐMp\쐬 */
static void	getaddress(char *address, char *str);
static CHAIN	*adr2chain(char*);
static void	delchain(CHAIN*);
static void	connectchain(CHAIN **dest, CHAIN *src);
static int	makeresinfo(char*, RES*);			/* ԐM擾 */
static void	getcharset(char *s, MIMEMACHINE *m);
static void	getencodetype(char *s, MIMEMACHINE *m);
static int	sgnselect();						/* I */
static void	sgnput(FILE*, int);					/*  */
static void	writereplyhead(FILE*, MAILDATA*, RES*);	/* p */
static void	putchain(FILE*, char*, CHAIN*);		/* o */


/* ԐMp\쐬Bd Re:  Re[num]: ɏ */
static char *
MakeResTitle(title, GetStr)
char	*title;
char	*GetStr;
{
	char	*w = title,
			*r = GetStr;

	strcpy(w, "Re: ");

	if (r[0] == 'R' && (r[1] & 0xdf) == 'E') {
		if (r[2] == '[') {
			/*  Res: */
			/* []̐lǂݏo */
			for (r += 3; *r && *r != ']'; r++);
			*r++ = '\0';

			/* 1傫Ȑ */
			sprintf(w + 2, "[%d]: ", atoi(GetStr + 3) + 1);

			/* Re[x]̎:܂łƂ΂ */
			for (; *r && *r != ':'; r++);
			r++;

		} else if (r[2] == ':') {
			/*  Res: */
			strcpy(w + 2, "[2]: ");
			r += 3;
		}
	}
	/* 󔒂̎o */
	for (; *r == ' '; r++);

	/* Subject𕡎 */
	strcat(w, r);
	return title;
}

/* smailő邽߂̃t@C쐬 */
static char	*MakeSentFile(char *File)
{
	FILE	*fp;
	int	SentNow = 0;
	char	*ptr = File;

	ptr = strcpy(File, Env.Mailbox);
	strcat(File, "send\\");	/* ܂send */
	while (*ptr)	ptr++;

	/* ŏ[ԍvZ */
	while (1) {
		itoa(SentNow, ptr, 10);

		if (fp = fopen(File, "rt")) {
			fclose(fp);
			SentNow++;
		} else {
			break;
		}
	}
	return File;
}

/*	From, To: ̋Lq
		O<AhX>, AhX(O), AhX̂
	3ނ̂ŁAʂăAhX𒊏o	*/
static void
getaddress(address, str)
char	*address;
char	*str;
{
	char	 *ptr,
			 *w = address;

	while (*str && *str <= ' ')	str++;

	if (ptr = strchr(str, '<')) {
		++ptr;
		while (*ptr && *ptr != '>')	*w++ = *ptr++;
	} else if (ptr = strchr(str, '(')) {
		while (str < ptr)	*w++ = *str++;
	} else {
		while (*str)	*w++ = *str++;
	}
	/* AhX̌ɋ󔒂̂h */
	while (w > address && *(w - 1) == ' ')	w--;
	*w = '\0';
}


static CHAIN *
adr2chain(str)
char	*str;
{
	CHAIN	*parent = NULL, *child, *tail;
	int	len;
	char	*r, *w, buf[128];

	r = str;
	while (*r) {
		w = buf;
		while (*r == ' ' || *r == '\t')	r++;
		while (*r != ',') {
			if (*r == '\"') {
				while (*r && *r != '\"')	*w++ = *r++;
			}
			if (!*r)	break;
			*w++ = *r++;
		}
		if (*r)	r++;
		*w = '\0';
		if (!(len = strlen(buf)))	continue;
		if (Env.xcc) {
			int	mine = FALSE;
			char	*ptr,
					*myadr = Env.xcc,
					address[128];
			getaddress(address, buf);
			ptr = address;
			while (1) {
				if (!*ptr && *myadr <= ' ') {
					mine = TRUE;
					break;
				}
				if (*myadr == *ptr) {
					ptr++;
					myadr++;
				} else {
					ptr = address;
					while (*myadr > ' ')	myadr++;
					if (!*myadr++)	break;
				}
			}
			if (mine)	continue;
		}
		child = malloc(sizeof(CHAIN) + len);
		if (child) {
			child->next = NULL;
			strcpy(child->buf, buf);
			if (parent) {
				tail->next = child;
				tail = child;
			} else {
				tail = parent = child;
			}
		} else {
			StatusPut("܂");
			break;
		}
	}
	return parent;
}

static void
delchain(parent)
CHAIN	*parent;
{
	while (parent) {
		CHAIN	*child = parent->next;

		free(parent);
		parent = child;
	}
}

static void
connectchain(dest, src)
CHAIN	**dest;
CHAIN	*src;
{
	CHAIN	*c;

	if (!src)	return;

	if (c = *dest) {
		while (c->next)	c = c->next;
		c->next = src;
	} else {
		*dest = src;
	}
}

/* XAhXԂBFrom: gAReply-To: g */
static int
makeresinfo(filename, res)
char	*filename;
RES	*res;
{
	FILE	*fp;
	int	i;
	SUBINF	inf;
	CHAIN	*From, *Reply, *Cc, *Other;
	char	*ptr,
			temp[BUFMAX];

	res->to = NULL;
	res->MesID[0] = '\0';
	res->subject[0] = '\0';

	From = NULL;
	Reply = NULL;
	Cc = NULL;
	Other = NULL;

	strcpy(temp, CDir);
	strcat(temp, Mail[TargetNum].filename);

	if (!(fp = fopen(temp, "rt"))) {	/* BI */
		StatusPut("[ǂ߂܂");
		return FALSE;
	}

	/* AhX֌WTBsŏI */
	while (fgets822a(temp, BUFMAX, fp)) {
		decode_mime(temp, temp);
		if (ptr = GetKeyword(temp, "FROM:")) {
			if (From)	delchain(From);
			From = adr2chain(ptr);	/* From 擾 */
		} else if (ptr = GetKeyword(temp, "RETURN-PATH:")) {
			/* From Ȃ Return-Path擾 */
			if (!From)	From = adr2chain(ptr);
		} else if (ptr = GetKeyword(temp, "REPLY-TO:")) {
			Reply = adr2chain(ptr);	/* Reply-To擾 */
		} else if(ptr = GetKeyword(temp, "TO:")) {
			Other = adr2chain(ptr);	/* To: 擾 */
		} else if (ptr = GetKeyword(temp, "CC:")) {
			Cc = adr2chain(ptr);		/* Cc擾 */
		} else if (ptr = GetKeyword(temp, "SUBJECT:")) {
			/* Subject 擾 */
			jstrncpy(res->subject, ptr, RESSTR_MAX);
		} else if(ptr = GetKeyword(temp, "MESSAGE-ID:")) {
			/* Message-ID: 擾 */
			jstrncpy(res->MesID, ptr, RESSTR_MAX);
		}
	}
	fclose(fp);

	/* 惊Xg */
	connectchain(&Other, Cc);
	connectchain(&From, Other);
	connectchain(&Reply, From);
	res->to = Reply;

	/* 惊Xg̗vf𐔂 */
	for (i = 0, Reply = res->to; Reply; i++) {
		Reply = Reply->next;
	}

	/* 悪1(ԂFrom)Ȃ烊^[ */
	if (i <= 1)	return TRUE;

	if (!alloc_subwin(&inf, i)) {
		StatusPut("܂");
		delchain(res->to);
		res->to = NULL;
		return FALSE;
	}
	inf.WinMax = i;

	for (i = 0, Reply = res->to; i < inf.WinMax; i++) {
		strcpy(temp, Reply->buf);
		extract_name(inf.WinMember[i].name, temp, MSTR_MAX);
		Reply = Reply->next;
	}

	/* EBhEp */
	/* I */
	i = WinManager(&inf, "      ԐM̑I", 2);

	if (i < 0) {
		free_subwin(&inf);
		delchain(res->to);
		res->to = NULL;
		return FALSE;
	}
	if (!inf.WinOnNum)	inf.WinMember[i].On = TRUE;
	Reply = res->to;
	for (i = 0; i < inf.WinMax; i++) {
		Other = Reply->next;
		if (inf.WinMember[i].On) {
			From = Reply;
		} else {
			if (Reply == res->to) {
				From = res->to = Other;	/* 2000/01/20 */
			} else {
				From->next = Other;
			}
			free(Reply);
		}
		Reply = Other;
	}
	free_subwin(&inf);
	return TRUE;
}

static void
getcharset(s, m)
char	*s;
MIMEMACHINE	*m;
{
/*
	while (*s != ';') {
		if (!*s++)	return;
	}
	s++;
	while (*s <= ' ')	s++;
	if (!striequ(s, "charset="))	return;
	s += sizeof(CHARSET_HEADER);
*/
	while (*s != '=') {
		if (!*s++)	return;
	}
	s++;

	if (*s == '\"')	s++;


	if (headicmp(s, JIS_HEADER)) {
		m->converter = jis2sjis;
	} else if (headicmp(s, EUC_HEADER)) {
		m->converter = euc2sjis;
	} else if (headicmp(s, SJIS_HEADER)) {
		m->converter = NULL;
	}
}


static void
getencodetype(s, m)
char	*s;
MIMEMACHINE	*m;
{
/*	while (*s != ':')	s++;
	s++;
	while (*s == ' ' || *s == '\t')	s++;
*/
	if (headicmp(s, "BASE64")) {
		m->decoder = decbenc;
	} else if (headicmp(s, "QUOTED-PRINTABLE")) {
		m->decoder = decqenc;
	} else {
		m->decoder = NULL;
	}
}


/* TargetNum ̃[MIMEfR[hďo */
void	MakeViewFile(FILE *wfp, char *head)
{
	FILE	*rfp;
	MIMEMACHINE	m;
	char	BoundaryFlag = 0, BoundaryNum = 0,
			*tmp, Boundary[LINE_MAX] = "--",
			work[BUFMAX];

	m.decoder = NULL;
	m.converter = Env.defconverter;	/* default charset */

	strcpy(work, CDir);
	strcat(work, Mail[TargetNum].filename);
	rfp = fopen(work, "rt");
	if (!rfp) {
		StatusPut("[ǂ߂܂Bdateman.x蒼Ă");
		return;
	}


	/* wb_΂B̉ߒBOUNDARYE */
	while (fgets822a(work, sizeof(work), rfp)) {
		decode_mime(work, work);

		/* wb_\[hȂo */
		if (Env.FilePutFlag) {
			if (head)	fputs(head, wfp);
			fputs(work, wfp);
		}

		if (tmp = strstr(work, "boundary=")) {	/* boundary o */
			char	*w = Boundary + 2;
			tmp += 9;
			if (*tmp == '\"') {	/* p */
				tmp++;
				while (*tmp && *tmp != '\"')	*w++ = *tmp++;
				*w++ = '\n';
				*w = '\0';
			} else {
				strcpy(w, tmp);
			}
			BoundaryFlag = 1;
		} else if (headicmp(work, "X-ATTACHMENT:")) {
			BoundaryFlag = -1;	/* Ytt@C */
		} else if (tmp = GetKeyword(work, "CONTENT-TYPE:")) {
			getcharset(tmp, &m);
		} else if (tmp = GetKeyword(work, "CONTENT-TRANSFER-ENCODING:")) {
			getencodetype(tmp, &m);
		}
	}
	if (Env.FilePutFlag) {
		if (head)	fputs(head, wfp);
		fputc('\n', wfp);
	}

	while (fgets(work, sizeof(work), rfp)) {
		if (BoundaryFlag > 0 && *work == '-' && !strcmp(work, Boundary)) {
			/* boundaryQ񌩂΂܂ */
			if (++BoundaryNum == 1) {		/* ĂёsT */
				while (fgets822a(work, BUFMAX, rfp)) {
					if (tmp = GetKeyword(work, "CONTENT-TYPE:")) {
						getcharset(tmp, &m);
					} else if (tmp = GetKeyword(work, "CONTENT-TRANSFER-ENCODING:")) {
						getencodetype(tmp, &m);
					}
				}
				continue;
			} else {
				break;
			}
		}

		if (m.decoder)	m.decoder(work, work);
		if (m.converter)	m.converter(work, work);

		if (head)	fputs(head, wfp);
		fputs(work, wfp);
	}

	if (BoundaryFlag) {
		if (!head) {
			fputs("\n -------------      }`p[g[ł      ------------- \n\n",
					wfp);
		}
		if (!(Mail[TargetNum].fileflag & M_CLIP)) {
			Mail[TargetNum].fileflag |= M_CLIP;	/* ꉞłtO𗧂ĂĂ */
			SaveFlag = TRUE;
		}
	}

	fclose(rfp);
}

static void
writereplyhead(fp, mail, res)
FILE	*fp;
MAILDATA	*mail;
RES	*res;
{
	unsigned char	*p = Env.replyhead;	/* MVIEW.RC */

	while (1) {
		if (*p == '\\') {
			if (*++p == 'n') {
				fputc('\n', fp);
				p++;
				continue;
			}
		} else if (*p == '$') {
			switch (*++p & 0xdf) {
			case 'S':	fputs(res->subject, fp);	break;
			case 'N':	fputs(mail->name, fp);		break;
			case 'D':	fputs(mail->year, fp);		break;
			case 'T':	fputs(mail->time, fp);		break;
			case '\0':	continue;
			}
			p++;
			continue;
		}
		if (!nosjis[*p]) {
			if (!p[1])	break;
			fputc(*p++, fp);
		} else if (!*p)	break;
		fputc(*p++, fp);
	}
	fputs("\n\n", fp);
}

static void
putchain(fp, head, parent)
FILE	*fp;
char	*head;
CHAIN	*parent;
{
	CHAIN	*child;
	int	alllen = strlen(head), len;
	char	*p, temp[128];

	strcpy(temp, head);
	p = temp + alllen;
	while (parent) {
		len = strlen(parent->buf);
		if (alllen + len >= 80) {
			*p++ = '\n';
			*p = '\0';
			fputs(temp, fp);
			p = temp;
			*p++ = '\t';
			alllen = 1;
		}
		strcpy(p, parent->buf);
		p += len;
		alllen += len;
		if (child = parent->next) {
			*p++= ',';
			*p++= ' ';
			alllen += 2;
		}
		parent = child;
	}
	if (alllen > 1) {
		*p++ = '\n';
		*p = '\0';
		fputs(temp, fp);
	}
}

/* X|X */
void ResMail(void)
{
	FILE	*fp;
	RES	*res;
	int	i = 0;
	char	MailFile[FILNMAX], Work[LINE_MAX];

	res = malloc(sizeof(RES));
	if (!res) {
		StatusPut("܂");
		return;
	}

	StatusPut("ԐM[Ă܂");

	/* [`FbN */
	strcpy(Work, CDir);
	strcat(Work, Mail[TargetNum].filename);
	if (!makeresinfo(Work, res)) {
		/* LZ΋I */
		free(res);
		PutScreen();
		return;
	}

/*	PutScreen();*/
	/* V@\VOlC`ǉ */
	if (Env.SignatureNow) {
		i = sgnselect();
		if (i < 0) {
			delchain(res->to);
			free(res);
			PutScreen();
			return;
		}
	}

/*	PutScreen();*/
/*	StatusPut("ԐM[Ă܂");*/
	MakeSentFile(MailFile);
	if (!(fp = fopen(MailFile, "wt"))) {
		StatusPut("VK[̍쐬Ɏs܂");
		delchain(res->to);
		free(res);
		return;
	}

	fprintf(fp, "Subject: %s\n", MakeResTitle(Work, res->subject));
	strcpy(Work, "To: ");
	putchain(fp, Work, res->to);
	delchain(res->to);

	/* Cc: ͕WłZbg */
	/* default Cc ݒ肳ĂΎg */
	fprintf(fp, "Cc: %s\n", Env.Cc);

	/* default Reply ݒ肳ĂΎg */
	if (Env.Reply)	fprintf(fp, "Reply-To: %s\n", Env.Reply);

	if (res->MesID[0]) {
		fprintf(fp, "In-Reply-To: %s\n", res->MesID);
		fprintf(fp, "References: %s\n", res->MesID);
	}
	/* wb_I */
	fputc('\n', fp);
	free(res);

	if (Env.replyhead)	writereplyhead(fp, &(Mail[TargetNum]), res);

	MakeViewFile(fp, Env.Qmark);

	if (i)	sgnput(fp, i);
	fclose (fp);

	if (execedit(MailFile, TRUE)) {
		if (!(Mail[TargetNum].fileflag & M_RES)) {
			Mail[TargetNum].fileflag |= M_RES;
			SaveFlag = TRUE;
		}
	}
}

/* Vȃ[ */
void	WriteMail(mail, dir)
MAILDATA	*mail;
char	*dir;
{
	FILE	*fp;
	int	i, AddressOnNum = 0;
	SUBINF	inf;
	char	MailFile[FILNMAX], temp[BUFMAX];

	if (abook.Now) {
		if (!alloc_subwin(&inf, abook.Now))	return;
		inf.WinMax = abook.Now;
		for (i = 0; i < abook.Now; i++) {
			strcpy(inf.WinMember[i].name, abook.Address[i].name);
		}
		/* I */
		i = WinManager(&inf, "       ̑I", 1);
		AddressOnNum = inf.WinOnNum;				/* }[N𐔂 */
		if (i >= 0) {
			int	j;
			for (j = 1; j < abook.Now; j++) {
				abook.Address[j].On = inf.WinMember[j].On;
			}
			if (!AddressOnNum && i > 0) {
				AddressOnNum = 1;
				abook.Address[i].On = TRUE;
			}
		}
		free_subwin(&inf);

		if (i < 0) {	/* ~ */
			PutScreen();
			return;
		}
	}

	i = 0;
	if (Env.SignatureNow) {		/* ǉ */
		i = sgnselect();
		if (i < 0) {
			PutScreen();
			return;
		}
	}

	MakeSentFile(MailFile);
	fp = fopen(MailFile, "wt");
	if (!fp) {
		StatusPut("VK[쐬ł܂");
		return;
	}
	fprintf(fp, "Subject: %s\nTo: ", Env.DefSubject);
	if (AddressOnNum) {
		int	j, alllen = 4, len;

		temp[0] = '\0';
		for (j = 1; j < abook.Now; j++) {
			if (abook.Address[j].On) {
				len = strlen(abook.Address[j].address);
				if ((alllen += len) >= 80) {
					alllen = 2 + len;
					fputs(temp, fp);
					strcpy(temp, "\n\t");
				}
				strcat(temp, abook.Address[j].address);
				if (!--AddressOnNum)	break;
				strcat(temp, ", ");
				alllen += 2;
			}
		}
		if (alllen > 2)	fputs(temp, fp);
	}

	fprintf(fp, "\nCc: %s\n", Env.Cc);	/* ʐݒ荀 */
	if (Env.Reply)	fprintf(fp, "Reply-To: %s\n", Env.Reply);
	fputc('\n', fp);
	if (i)	sgnput(fp, i);

	/* ] */
	if (mail) {
		FILE	*ffp;

		fputs("\n-- forward message --\n\n", fp);
		strcpy(temp, dir);
		strcat(temp, mail->filename);
		if (ffp = fopen(temp, "rt")) {
			while (fgets(temp, BUFMAX, ffp))	fputs(temp, fp);
			fclose(ffp);
		} else {
			StatusPut("][ǂ߂܂");
		}
	}

	fclose(fp);

	execedit(MailFile, TRUE);
}

static int
sgnselect()
{
	int	i;
	SUBINF	inf;

	if (!alloc_subwin(&inf, Env.SignatureNow))	return 0;
	inf.WinMax = Env.SignatureNow;
	for (i = 0; i < Env.SignatureNow; i++) {
		strcpy(inf.WinMember[i].name, Env.SignatureName[i]);
	}
/*	inf.SubWinBase = base;*/
	/* IȂ */
	i = WinManager(&inf, "       ̑I", 0);
	free_subwin(&inf);
	return i;
}

static void
sgnput(fp, sgnnumber)
FILE	*fp;
int	sgnnumber;
{
	FILE	*sfp;
	char	temp[256];

	strcpy(temp, Env.Mailbox);
	strcat(temp, Env.SignatureFile[sgnnumber]);
	if (!(sfp = fopen(temp, "rt"))) {
		sprintf(temp, "t@C %s ܂\n",
				Env.SignatureFile[sgnnumber] );
		StatusPut(temp);
	} else {
		fputs("\n\n", fp);
		while (fgets(temp, 256, sfp)) {
			fputs(temp, fp);
		}
		fclose(sfp);
	}
}
